'''拍照,采集图像作为数据集;
运行程序,终端输入1，表示采集"01Apple"数据集,待摄像头的画面启动后,按住按键a进行持续拍照,终端出现“image saved”字样,表示100张图片已采集完成”
之后重复上述操作,可采集02、03、04类数据集'''
import cv2 # 导入cv库
import os 

os.system('mkdir -p dataset_object_classification/01Apple')  # 创建文件夹以保存采集的图像
os.system('mkdir -p dataset_object_classification/02Banana')  # 创建文件夹以保存采集的图像
os.system('mkdir -p dataset_object_classification/03Watermelon')  # 创建文件夹以保存采集的图像
os.system('mkdir -p dataset_object_classification/04Others')  # 创建文件夹以保存采集的图像


number = input("请输入数据集文件夹编号:")
if number == "1":
    location = 'dataset_object_classification/01Apple/'
elif number == "2":
    location = 'dataset_object_classification/02Banana/'
elif number == "3":
    location = 'dataset_object_classification/03Watermelon/'
elif number == "4":
    location = 'dataset_object_classification/04Others/'
print(location)

def get_photo(): # 定义拍照函数(上传参数--图片保存地址)
    cap = cv2.VideoCapture(0) # 创建一个 VideoCapture 对象, 构建视频抓捕器, 0表示需要启动的摄像头 
    cap.set(cv2.CAP_PROP_BUFFERSIZE, 1) # Set the camera buffer to 1, to decrease the latency. # 设置1帧的缓冲，减少延迟避免卡顿
    cv2.namedWindow('window',cv2.WND_PROP_FULLSCREEN) # Set the windows to be full screen. # 构建一个窗口,名称为window,属性为可以全屏
    cv2.setWindowProperty('window', cv2.WND_PROP_FULLSCREEN, cv2.WINDOW_FULLSCREEN) # Set the windows to be full screen. # 设置窗口全屏
    count = 0
    
    while (cap.isOpened()): # 循环读取每一帧
        ret, frame = cap.read() # 从摄像头读取图片 , ret存储布尔值，frame存储图像
        #frame = cv2.flip(frame, 1, dst=None) # 镜像
        cv2.imshow("window", frame) # 窗口显示,显示名为 window
        # 保持画面的持续。
        key = cv2.waitKey(1) # 每帧数据延时1ms,延时不能为 0,否则读取的结果会是静态帧
        if key & 0xFF == ord('b'): # 按b键退出
            break
        elif key & 0xFF == ord('a'): # 通过a键保存图片，并退出。
            if count < 100:  # 100张图片，可自行修改数量
                global location
                cv2.imwrite(location+ str(count) + ".jpg", frame) # 将图像保存为图片
                count = count + 1
                # print(count)
            else:
                print("image saved")
    cap.release()  # 释放摄像头
    cv2.destroyAllWindows()  # 关闭所有窗口

get_photo()  # 调用拍照函数,同时传入要保存的图片名称
