'''用“dataset_object_classification/03Watermelon/2.jpg”图片进行预测,检验模型准确率；
运行程序，待计算机自动导入模型进行预测，随后会在终端显示该图片在四个类别下的不同分类概率，以及取概率最高的类别作为最终结果
PS:本程序非必须'''

# 导入tensorflow深度学习框架
import tensorflow as tf
# 导入keras深度学习库
from tensorflow import keras
# 导入数据处理库
import numpy as np


# 导入物体分类模型
print("导入模型中...")
model_name = "object_classification_model.h5"
model = tf.keras.models.load_model(model_name)
print("{}模型导入完成".format(model_name))


# 输出预测结果
img = keras.preprocessing.image.load_img("dataset_object_classification/01Apple/2.jpg", target_size=(96, 96))
img2 = keras.preprocessing.image.load_img("dataset_object_classification/02Banana/2.jpg", target_size=(96, 96))
img3 =keras.preprocessing.image.load_img("dataset_object_classification/03Watermelon/2.jpg", target_size=(96, 96))
img4 =keras.preprocessing.image.load_img("dataset_object_classification/04Others/2.jpg", target_size=(96, 96))
# 图像预处理
img_array = keras.preprocessing.image.img_to_array(img3)                  # 将图像数据转换为数组    #  用img3进行预测，可自行修改
img_array = keras.applications.mobilenet_v2.preprocess_input(img_array)  # 将数组处理成适合mobilenet_v2的输入格式
img_array = tf.expand_dims(img_array, 0)                                 # 在图像数组前面增加一维，即将 (224,224,3) 的图像矩阵变成 (1,224,224,3)

# 定义分类结果的名称，按照数据集中的文件夹顺序，神经网络的输出依次为01-04
class_names = ["01Apple","02Banana","03Watermelon","04Others"] 

# 预测
print("预测结果为：")
predictions = model.predict(img_array)  # 预测图像（整体概率）
print(predictions)
result = class_names[predictions.argmax()]  # 预测结果（概率最高者）
print(result)
